from tkinter import *
import random
import math


class Strichmann:
    def __init__(self):
        self._Jump_t = 0.01
        self._letzte_Koordinate = 100000
        self._Falling = False
        self._x_Faktor = 1
        self._Jump = True
        self._difficulty = 0.03
        self._Weg_Koordinate = 0

        self._Sprunghöhe = 150
        self._Springpunkt = 400

        self._Flying_Strichmann = PhotoImage(file="Flying_Strichmann.png")
        self._Jumping_Strichmann = PhotoImage(file="Jumping_Strichmann.png")
        self._Figur_Flying = canvas.create_image(1500, 1500, image=self._Flying_Strichmann)
        self._Figur_Jumping = canvas.create_image(1500, 1500, image=self._Jumping_Strichmann)

    def jump(self):
        if self._Jump:
            weg_rechnung = 5 * self._Jump_t - 0.5 * 10 * self._Jump_t ** 2
            self._Jump_t += self._difficulty

            weg_prozent = weg_rechnung / 1.25 * 100
            weg_pixel = self._Sprunghöhe * weg_prozent / 100
            self._Weg_Koordinate = self._Springpunkt - weg_pixel

            canvas.coords(self._Figur_Flying, 950, self._Weg_Koordinate)
            canvas.coords(self._Figur_Jumping, 1500, 1500)
            if 110 < self._Weg_Koordinate < 770:
                canvas.after(15, self.jump)
            else:
                M.dead()

        else:
            self._Jump = True
            canvas.coords(self._Figur_Flying, 1500, 1500)
            canvas.coords(self._Figur_Jumping, 950, self._Weg_Koordinate)
            self._Springpunkt = self._Weg_Koordinate
            self._Jump_t = 0.01
            canvas.after(150, self.jump)


class Button:
    def __init__(self):
        self._Unterlage = canvas.create_rectangle(0, 0, 1000, 1000, width=0, fill="", tags="Unterlage")
        self._b = canvas.create_rectangle(random.randint(0, 900), random.randint(0, 860), random.randint(0, 900),
                                          random.randint(0, 860), fill="red", tags="Klick")
        canvas.tag_bind("Klick", "<1>", self.löschen)
        canvas.tag_bind("Unterlage", "<1>", self.daneben)

    def löschen(self, event):
        canvas.delete(self._b)
        self._b = canvas.create_rectangle(random.randint(0, 900), random.randint(0, 860), random.randint(0, 900),
                                          random.randint(0, 860), fill="red", tags="Klick")
        M.clicked(event.x, event.y)

    @staticmethod
    def daneben(event):
        M.clicked_daneben(event.x, event.y)


class Manager:
    def __init__(self):
        self._difficulty = "Einfach"
        self._ingame = False
        self._Schild = PhotoImage(file="Schild.png")
        self._Herz = PhotoImage(file="Herz.png")
        self._Leben = 11
        self._Lebensanzeige = []
        self._Score = 0
        self._dead = True
        self._AllScores = []
        self._ScoreAnzeige = None
        self._SpielernameTXT = ""

        self._B = Button()
        self._S = Strichmann()

        self._StartButtonTXT = None
        self._StartButton = None
        self._NameEntry = None
        self._Spielername = None
        self._NameAnzeige = None
        self._Anleitung2 = None
        self._Anleitung1 = None
        self._Anleitung_Titel = None
        self._Highscores_Titel = None
        self._RadioButtonSchwerTXT = None
        self._RadioButtonNormalTXT = None
        self._RadioButtonEinfachTXT = None
        self._Titel = None
        self._Hintergrund = None
        self._deckblatt = None

        self.create_menue_elements()

        self._RadioButtonEinfach = canvas.create_oval(200, 350, 220, 370, fill="red", tag="RBtnEinfach",
                                                      activeoutline="green", activewidth=3)
        self._RadioButtonNormal = canvas.create_oval(200, 390, 220, 410, fill="white", tag="RBtnNormal",
                                                     activeoutline="green", activewidth=3)
        self._RadioButtonSchwer = canvas.create_oval(200, 430, 220, 450, fill="white", tag="RBtnSchwer",
                                                     activeoutline="green", activewidth=3)

        self.get_scores()
        self._Highscore1 = None
        self._Highscore2 = None
        self._Highscore3 = None
        self._Highscore4 = None
        self._Highscore5 = None
        self._Highscore6 = None
        self._Highscore7 = None
        self._Highscore8 = None
        self._Highscore9 = None
        self._Highscore10 = None
        self.show_scores()

        canvas.tag_bind("RBtnEinfach", "<1>", self.changed_difficulty_to_easy)
        canvas.tag_bind("RBtnNormal", "<1>", self.changed_difficulty_to_normal)
        canvas.tag_bind("RBtnSchwer", "<1>", self.changed_difficulty_to_schwer)
        canvas.tag_bind("Start", "<1>", self.start)

    def start(self, event):
        if not self._ingame:
            self._Score = 0
            self._ingame = True
            self._NameEntry.destroy()
            canvas.delete(self._Highscores_Titel, self._Highscore1, self._Highscore2, self._Highscore3,
                          self._Highscore4, self._Highscore5, self._Highscore6, self._Highscore7, self._Highscore8,
                          self._Highscore9, self._Highscore10, self._Titel, self._Anleitung_Titel, self._Anleitung1,
                          self._Anleitung2, self._StartButton, self._StartButtonTXT, self._Hintergrund, self._deckblatt,
                          self._RadioButtonEinfach, self._RadioButtonNormal, self._RadioButtonSchwer,
                          self._RadioButtonEinfachTXT, self._RadioButtonNormalTXT, self._RadioButtonSchwerTXT,
                          self._NameAnzeige)
            self.start_jump()
            self.generate_lebensanzeige()
            self._ScoreAnzeige = canvas.create_text(20, 880, text="0", font=("Impact", 20))
            self._SpielernameTXT = self._Spielername.get()[:15]
            if len(self._SpielernameTXT) == 0:
                self._SpielernameTXT = "Anonym"
            else:
                temp_spielername_txt = ""
                for i in self._SpielernameTXT:
                    if i != " ":
                        temp_spielername_txt += i
                self._SpielernameTXT = temp_spielername_txt

    def start_jump(self):
        self._S.__init__()
        self._S.jump()
        self._dead = False
        if self._difficulty == "Eeinfach":
            self._S._difficulty = 0.01
        elif self._difficulty == "Normal":
            self._S._difficulty = 0.03
        elif self._difficulty == "Schwer":
            self._S._difficulty = 0.05  # Schwierigkeitsgrad ändern

    def clicked(self, x, y):
        self._S._Jump = False
        if self._ingame and self._dead:
            self.start_jump()
        if random.randint(0, 7) == 5:
            extraleben = random.randint(1, 3)
            self._Leben += extraleben
            self.delete_lebensanzeige()
            self.generate_lebensanzeige()
            self.animateleben(extraleben, x, y)
        self._Score += 1
        canvas.itemconfig(self._ScoreAnzeige, text=self._Score)

    def clicked_daneben(self, x, y):
        self._Leben -= 1
        self.delete_lebensanzeige()
        self.generate_lebensanzeige()
        self.animateleben(-1, x, y)

    def animateleben(self, leben, x, y):
        herzen = int(math.fabs(leben) / 3)
        schilde = math.fabs(leben) - herzen * 3
        animationlist = []
        coordinates = [0, y]
        incementalx = 0
        while herzen > 0:
            animationlist.append(canvas.create_image(x + incementalx, y, image=self._Herz))
            coordinates.append(x + incementalx)
            herzen -= 1
            incementalx += 35
        while schilde > 0:
            animationlist.append(canvas.create_image(x + incementalx, y, image=self._Schild))
            coordinates.append(x + incementalx)
            schilde -= 1
            incementalx += 35
        self.leben_animation(animationlist, coordinates, leben)

    def leben_animation(self, items, coordinates, leben):
        coordinates[0] += 1
        if leben > 0:
            coordinates[1] -= coordinates[0]
        elif leben < 0:
            coordinates[1] += coordinates[0]
        inc = 2
        for i in items:
            canvas.coords(i, coordinates[inc], coordinates[1])
            inc += 1
        if -100 < coordinates[1] < 1000:
            canvas.after(20, self.leben_animation, items, coordinates, leben)
        else:
            for i in items:
                canvas.delete(i)

    def get_scores(self):
        self._AllScores = []
        scoresfile = open("Scores" + self._difficulty + ".txt", "r")
        for i in scoresfile:
            self._AllScores.append(i.rstrip().split())
        scoresfile.close()

    def set_scores(self):
        scoresfile = open("Scores" + self._difficulty + ".txt", "w")
        for i in self._AllScores:
            scoresfile.write(i[0] + " " + i[1] + "\n")
        scoresfile.close()

    def generate_score_list(self, i):
        if int(self._AllScores[i][1]) > self._Score:
            i += 1  # error index out of range if theres a bad player
            self.generate_score_list(i)
        else:
            recentscore = [self._SpielernameTXT, str(self._Score)]
            self._AllScores.insert(i, recentscore)
            self.set_scores()

    def show_scores(self):
        canvas.delete(self._Highscore1, self._Highscore2, self._Highscore3, self._Highscore4, self._Highscore5,
                      self._Highscore6, self._Highscore7, self._Highscore8, self._Highscore9, self._Highscore10)
        self._Highscore1 = canvas.create_text(330, 560, text=self._AllScores[0][0] + " - " + self._AllScores[0][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore2 = canvas.create_text(330, 575, text=self._AllScores[1][0] + " - " + self._AllScores[1][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore3 = canvas.create_text(330, 590, text=self._AllScores[2][0] + " - " + self._AllScores[2][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore4 = canvas.create_text(330, 605, text=self._AllScores[3][0] + " - " + self._AllScores[3][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore5 = canvas.create_text(330, 620, text=self._AllScores[4][0] + " - " + self._AllScores[4][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore6 = canvas.create_text(330, 635, text=self._AllScores[5][0] + " - " + self._AllScores[5][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore7 = canvas.create_text(330, 650, text=self._AllScores[6][0] + " - " + self._AllScores[6][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore8 = canvas.create_text(330, 665, text=self._AllScores[7][0] + " - " + self._AllScores[7][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore9 = canvas.create_text(330, 680, text=self._AllScores[8][0] + " - " + self._AllScores[8][1],
                                              fill="white", font=("Arial", 10))
        self._Highscore10 = canvas.create_text(330, 695, text=self._AllScores[9][0] + " - " + self._AllScores[9][1],
                                               fill="white", font=("Arial", 10))

    def dead(self):
        self._dead = True
        self._Leben -= 3
        if self._Leben <= 0:
            self._ingame = False
            self.delete_lebensanzeige()
            self.game_over()
        else:
            self.delete_lebensanzeige()
            self.generate_lebensanzeige()
            self.animateleben(-3, fenster.winfo_pointerx() - fenster.winfo_rootx(),
                              fenster.winfo_pointery() - fenster.winfo_rooty())

    def game_over(self):
        canvas.delete(self._ScoreAnzeige)
        self._ingame = False
        self.generate_score_list(0)
        self.delete_lebensanzeige()

        self.create_menue_elements()

        if self._difficulty == "Einfach":
            self.changed_difficulty_to_easy()
        elif self._difficulty == "Normal":
            self.changed_difficulty_to_normal()
        elif self._difficulty == "Schwer":
            self.changed_difficulty_to_schwer()

        self._Leben = 11

    def generate_lebensanzeige(self):
        self._Lebensanzeige = []
        herzen = int(self._Leben / 3)
        schilde = self._Leben - herzen * 3
        x_pos = 60
        while herzen > 0:
            self._Lebensanzeige.append(canvas.create_image(x_pos, 880, image=self._Herz))
            herzen -= 1
            x_pos += 35
        while schilde > 0:
            self._Lebensanzeige.append(canvas.create_image(x_pos, 880, image=self._Schild))
            schilde -= 1
            x_pos += 35

    def delete_lebensanzeige(self):
        for i in self._Lebensanzeige:
            canvas.delete(i)
        self._Lebensanzeige = []

    def changed_difficulty_to_easy(self, event=None):
        self._difficulty = "Einfach"
        self.get_scores()
        self.show_scores()
        canvas.delete(self._RadioButtonEinfach, self._RadioButtonNormal, self._RadioButtonSchwer)
        self._RadioButtonEinfach = canvas.create_oval(200, 350, 220, 370, fill="red", tag="RBtnEinfach",
                                                      activeoutline="green", activewidth=3)
        self._RadioButtonNormal = canvas.create_oval(200, 390, 220, 410, fill="white", tag="RBtnNormal",
                                                     activeoutline="green", activewidth=3)
        self._RadioButtonSchwer = canvas.create_oval(200, 430, 220, 450, fill="white", tag="RBtnSchwer",
                                                     activeoutline="green", activewidth=3)

    def changed_difficulty_to_normal(self, event=None):
        self._difficulty = "Normal"
        self.get_scores()
        self.show_scores()
        canvas.delete(self._RadioButtonEinfach, self._RadioButtonNormal, self._RadioButtonSchwer)
        self._RadioButtonEinfach = canvas.create_oval(200, 350, 220, 370, fill="white", tag="RBtnEinfach",
                                                      activeoutline="green", activewidth=3)
        self._RadioButtonNormal = canvas.create_oval(200, 390, 220, 410, fill="red", tag="RBtnNormal",
                                                     activeoutline="green", activewidth=3)
        self._RadioButtonSchwer = canvas.create_oval(200, 430, 220, 450, fill="white", tag="RBtnSchwer",
                                                     activeoutline="green", activewidth=3)

    def changed_difficulty_to_schwer(self, event=None):
        self._difficulty = "Schwer"
        self.get_scores()
        self.show_scores()
        canvas.delete(self._RadioButtonEinfach, self._RadioButtonNormal, self._RadioButtonSchwer)
        self._RadioButtonEinfach = canvas.create_oval(200, 350, 220, 370, fill="white", tag="RBtnEinfach",
                                                      activeoutline="green", activewidth=3)
        self._RadioButtonNormal = canvas.create_oval(200, 390, 220, 410, fill="white", tag="RBtnNormal",
                                                     activeoutline="green", activewidth=3)
        self._RadioButtonSchwer = canvas.create_oval(200, 430, 220, 450, fill="red", tag="RBtnSchwer",
                                                     activeoutline="green", activewidth=3)

    def create_menue_elements(self):
        self._deckblatt = canvas.create_rectangle(0, 0, 1000, 900, fill="#FFFFFF", width=0)
        self._Hintergrund = canvas.create_rectangle(150, 200, 850, 800, fill="#A0A0A0", width=0)
        self._Titel = canvas.create_text(500, 250, text="Inbetween Death", fill="red", font=("Impact", 25))

        self._RadioButtonEinfachTXT = canvas.create_text(250, 360, text="Einfach", fill="white")
        self._RadioButtonNormalTXT = canvas.create_text(250, 400, text="Normal", fill="white")
        self._RadioButtonSchwerTXT = canvas.create_text(250, 440, text="Schwer", fill="white")

        self._Highscores_Titel = canvas.create_text(330, 530, text="Highscores", fill="white", font=("Impact", 15))
        self._Anleitung_Titel = canvas.create_text(500, 310, text="Anleitung", fill="white", font=("Impact", 15))
        self._Anleitung1 = canvas.create_text(570, 360,
                                              text="Ziel des Spiels ist es, sich selbs so lange wie es geht am leben"
                                                   " zu erhalten.\rDurch klicken auf die roten Kästen, springen Sie."
                                                   "\rWenn sie zu langsam sind, fallen Sie durch die Schwerkraft ins "
                                                   "Feuer.\rWenn Sie aber zu übermütig klicken, springen sie gereadewe"
                                                   "gs gegen die Eiszapfen in den Tod.",
                                              fill="white")
        self._Anleitung2 = canvas.create_text(570, 440,
                                              text="Unten links sehen Sie ihre Lebensanzeige.\rJedes mal, wenn sie ste"
                                                   "rben, wird ihnen ein Herz abgezogen.\rJedes Herz besteht aus 3 Schi"
                                                   "lder.\rImmer wenn sie daneben klicken, verlieren sie ein Schild.\r"
                                                   "Hin und wieder bekommen Sie ein paar Schilder oder gar ein Herz gu"
                                                   "tgeschrieben,\rwenn Sie aud einen roten Kasten klicken.           "
                                                   "                                                                  "
                                                   "                   ",
                                              fill="white")

        self._NameAnzeige = canvas.create_text(520, 550, text="Name: ", fill="white")
        self._Spielername = StringVar()
        self._NameEntry = Entry(canvas, textvariable=self._Spielername, justify=CENTER)
        canvas.create_window(600, 550, window=self._NameEntry)
        self._Spielername.set(self._SpielernameTXT)

        self._StartButton = canvas.create_rectangle(500, 600, 700, 700, fill="#ff5050", width=10, outline="#FFFFFF",
                                                    tag="Start", activeoutline="green")
        self._StartButtonTXT = canvas.create_text(600, 650, fill="#FFFFFF", text="Start", font=("Arial", 20),
                                                  tag="Start", state=DISABLED)


fenster = Tk()
canvas = Canvas(fenster, width=1000, height=900, cursor="target", background="#FFFFFF", highlightthickness=0)

feuer = PhotoImage(file="feuer.png")
canvas.create_image(950, 850, image=feuer)
eis = PhotoImage(file="eis.png")
canvas.create_image(950, 50, image=eis)

M = Manager()

canvas.pack()
fenster.mainloop()
